#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define mp make_pair
#define mt make_tuple
#define sz size()
#define pb push_back
#define SPED ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0)
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()
#define inv(n) power((n), mod - 2)
#define ff(i,a,b) for (int (i) = (a); (i) < (b); (i)++)
#define fff(i,a,b) for (int (i) = (a); (i) <= b; (i)++)
#define bff(i,a,b) for (int (i) = (b)-1; (i) >= (a); (i)--)
#define bfff(i,a,b) for (int (i) = (b); (i) >= (a); (i)--)
#define sum_overflow(a,b) __builtin_add_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)
#define mul_overflow(a,b) __builtin_mul_overflow_p ((a), (b), (__typeof__ ((a) * (b))) 0)
#define popcount(x) __builtin_popcountll(x)
#define PI 3.14159265358979323846

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef long long int ll;
typedef long double ld;
typedef unsigned long long int ull;
typedef pair<ll,ll> pll;
typedef vector<vector<ll>> graf;
typedef array<ll,3> all;
typedef array<double,3> add;

const ll mod = 1e9+7;
const ll MOD = 998244353;
const ll MAXN = 200005;
const ll INF = 1e18;

template <class T> using ordered_set = tree<T, null_type,less<T>, rb_tree_tag,tree_order_statistics_node_update>;
template <class T> using ordered_multiset = tree<T, null_type,less_equal<T>, rb_tree_tag,tree_order_statistics_node_update>;

vector<vector<array<ll,2>>> g(MAXN);
vector<vector<ll>> dp(MAXN,vector<ll>(2,INF));
vector<bool> vis(MAXN);

void dfs(ll curr)
{
    vis[curr]=true;
    for(auto u : g[curr])
    {
        ll v = u[0];
        ll tip = u[1];
        if(!vis[v])
        {
            if(tip==0)
                dp[v][0]=min(min(dp[v][0],dp[curr][1]+1),dp[curr][0]);
            else
                dp[v][1]=min(min(dp[v][1],dp[curr][0]+1),dp[curr][1]);
            dfs(v);
        }
    }
    vis[curr]=false;
}

int main()
{
    SPED;
    ll n,m;
    cin >> n >> m;
    ff(i,0,m)
    {
        ll a,b,c;
        cin >> a >> b >> c;
        g[a].pb({b,c});
        g[b].pb({a,c});
    }
    ll poc,kraj;
    cin >> poc >> kraj;
    dp[poc][0]=0;
    dfs(poc);
    ll ans = min(dp[kraj][0],dp[kraj][1]);
    if(ans!=INF)
        cout << ans << "\n";
    else cout << "-1\n";
    return 0;
}